GTPin: GTReplay: Register State Inspection API

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

Functions
GTReplay: Register State Inspection API

A group of GTReplay APIs that provide access to the dynamic state of the emulated GEN instruction More...

## Functions
GTREPLAY_API uint32_t | GTReplay_DynamicExecMask (GTReplayIns ins, GTReplayState state)
GTREPLAY_API uint64_t | GTReplay_GetMemoryAccessAddr (GTReplayIns ins, GTReplayState state, uint32_t accessId)
GTREPLAY_API void | GTReplay_GetMemoryWriteValue (GTReplayIns ins, GTReplayState state, uint32_t accessId, uint8_t *data)
GTREPLAY_API void | GTReplay_GetDestination (GTReplayIns ins, GTReplayState state, uint32_t currentExecMask, uint8_t *dst, uint32_t *numOfElements, uint32_t *elementWidth)
GTREPLAY_API void | GTReplay_GetSrcOperand (GTReplayIns ins, GTReplayState state, uint32_t srcId, uint8_t *src, uint32_t *numOfElements, uint32_t *elementWidth)
GTREPLAY_API void | GTReplay_GetSendDestination (GTReplayIns ins, GTReplayState state, uint8_t *dst, uint32_t *numOfElements, uint32_t *elementWidth)
GTREPLAY_API uint32_t | GTReplay_GetGrfReg (GTReplayState state, uint32_t regNum, uint8_t *dst)
GTREPLAY_API uint32_t | GTReplay_GetGrfRegByte (GTReplayState state, uint32_t regNum, uint32_t regSubNum, uint8_t *reg)
GTREPLAY_API uint32_t | GTReplay_GetGrfRegWord (GTReplayState state, uint32_t regNum, uint32_t regSubNum, uint16_t *reg)
GTREPLAY_API uint32_t | GTReplay_GetGrfRegDword (GTReplayState state, uint32_t regNum, uint32_t regSubNum, uint32_t *reg)
GTREPLAY_API uint32_t | GTReplay_GetGrfRegQword (GTReplayState state, uint32_t regNum, uint32_t regSubNum, uint64_t *reg)

## Detailed Description

A group of GTReplay APIs that provide access to the dynamic state of the emulated GEN instruction

## Function Documentation

GTREPLAY_API uint32_t GTReplay_DynamicExecMask | ( | GTReplayIns | ins,
|  | GTReplayState | state
| ) |  |

Returns:
  instruction dynamic exec_mask: exec_mask[0:exec_size-1]

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.

Availability:
  - OnKernelBuild

GTREPLAY_API void GTReplay_GetDestination | ( | GTReplayIns | ins,
|  | GTReplayState | state,
|  | uint32_t | currentExecMask,
|  | uint8_t * | dst,
|  | uint32_t * | numOfElements,
|  | uint32_t * | elementWidth
| ) |  |

Return destination operand

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.
  [in] | currentExecMask | current execution mask
  [out] | dst | pointer to the data buffer for return value (it is responsibility of the caller to allocate enough space)
  [out] | numOfElements | pointer to a buffer where the number of elements is returned
  [out] | elementWidth | pointer to a buffer where the element width is returned

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetGrfReg | ( | GTReplayState | state,
|  | uint32_t | regNum,
|  | uint8_t * | dst
| ) |  |

Return specified GRF register -1 is returned in case of wrong parameters

Parameters:

  [in] | state | a state handle.
  [in] | regNum | register num
  [out] | dst | pointer to the data buffer for return value (it is responsibility of the caller to allocate enough space)

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetGrfRegByte | ( | GTReplayState | state,
|  | uint32_t | regNum,
|  | uint32_t | regSubNum,
|  | uint8_t * | reg
| ) |  |

Return single one-byte register value -1 is returned in case of wrong parameters

Parameters:

  [in] | state | a state handle.
  [in] | regNum | register num
  [in] | regSubNum | register sub num
  [out] | reg | pointer to a location where to return register value

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetGrfRegDword | ( | GTReplayState | state,
|  | uint32_t | regNum,
|  | uint32_t | regSubNum,
|  | uint32_t * | reg
| ) |  |

Return single one-dword register value -1 is returned in case of wrong parameters

Parameters:

  [in] | state | a state handle.
  [in] | regNum | register num
  [in] | regSubNum | register sub num
  [out] | reg | pointer to a location where to return register value

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetGrfRegQword | ( | GTReplayState | state,
|  | uint32_t | regNum,
|  | uint32_t | regSubNum,
|  | uint64_t * | reg
| ) |  |

Return single one-qword register value -1 is returned in case of wrong parameters

Parameters:

  [in] | state | a state handle.
  [in] | regNum | register num
  [in] | regSubNum | register sub num
  [out] | reg | pointer to a location where to return register value

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetGrfRegWord | ( | GTReplayState | state,
|  | uint32_t | regNum,
|  | uint32_t | regSubNum,
|  | uint16_t * | reg
| ) |  |

Return single one-word register value -1 is returned in case of wrong parameters

Parameters:

  [in] | state | a state handle.
  [in] | regNum | register num
  [in] | regSubNum | register sub num
  [out] | reg | pointer to a location where to return register value

Availability:
  - OnKernelBuild

GTREPLAY_API uint64_t GTReplay_GetMemoryAccessAddr | ( | GTReplayIns | ins,
|  | GTReplayState | state,
|  | uint32_t | accessId
| ) |  |

Returns:
  memory access address

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.
  [in] | accessId | an access ID

Availability:
  - OnKernelBuild

GTREPLAY_API void GTReplay_GetMemoryWriteValue | ( | GTReplayIns | ins,
|  | GTReplayState | state,
|  | uint32_t | accessId,
|  | uint8_t * | data
| ) |  |

Get memory write value

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.
  [in] | accessId | an access ID
  [out] | data | pointer to the data buffer for return value (it is responsibility of the caller to allocate enough space)

Availability:
  - OnKernelBuild

GTREPLAY_API void GTReplay_GetSendDestination | ( | GTReplayIns | ins,
|  | GTReplayState | state,
|  | uint8_t * | dst,
|  | uint32_t * | numOfElements,
|  | uint32_t * | elementWidth
| ) |  |

Return destination operand o fSEND instruction

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.
  [out] | dst | pointer to the data buffer for return value (it is responsibility of the caller to allocate enough space)
  [out] | numOfElements | pointer to a buffer where the number of elements is returned
  [out] | elementWidth | pointer to a buffer where the element width is returned

Availability:
  - OnKernelBuild

GTREPLAY_API void GTReplay_GetSrcOperand | ( | GTReplayIns | ins,
|  | GTReplayState | state,
|  | uint32_t | srcId,
|  | uint8_t * | src,
|  | uint32_t * | numOfElements,
|  | uint32_t * | elementWidth
| ) |  |

Return source operand

Parameters:

  [in] | ins | an instruction handle.
  [in] | state | a state handle.
  [in] | srcId | the ID of the source operand (0, 1, or 2)
  [out] | src | pointer to the data buffer for return value (it is responsibility of the caller to allocate enough space)
  [out] | numOfElements | pointer to a buffer where the number of elements is returned
  [out] | elementWidth | pointer to a buffer where the element width is returned

Availability:
  - execution

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT